#ifndef _CACHE_H
#define _CACHE_H

/* Copyright (c) 1994-96 Martin Buck  <martin-2.buck@student.uni-ulm.de>
 * Read COPYING for more information
 */


#include <sys/vtx.h>


typedef struct cache_s {		/* For internal use only! */
  byte_t buf[VTX_PAGESIZE];
  vtx_pageinfo_t info;
  int subpages_complete;		/* Only used in first element of linked list */
  struct cache_s *next;
} cache_t;

typedef struct {
  int page;
  cache_t *subpg_ptr;
} cache_loop_t;


void cache_insert(const byte_t *buffer, const vtx_pageinfo_t *info);
void cache_mark_complete(int page);
int cache_query(int page, int subpage, byte_t *buffer, vtx_pageinfo_t *info);
int cache_count_subpg(int page);
void cache_flush(void);
int cache_loop(cache_loop_t *last, byte_t *buffer, vtx_pageinfo_t *info);

#endif /* _CACHE_H */
